/*
 *	 LM75 auslesen
 *  ================
 *  Uwe Berger, 2012
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/i2c-dev.h>
#include <sys/ioctl.h>

/* I2C-Definitionen */
#define DEV_I2C		"/dev/i2c-2"
#define ADDR_LM75	0x49

#define DO_ERROR	{printf("Error...!\n"); exit(1);}

int  file;
unsigned char buffer[2], sign, dec;

int main(void) {
	
	/* Device oeffnen */
	file = open(DEV_I2C, O_RDWR);
	if (file < 0) DO_ERROR;
	if (ioctl(file, I2C_SLAVE, ADDR_LM75)) DO_ERROR;
	
	/* Temperatur auslesen */
	buffer[0] = 0x00;
	if (write(file, buffer, 1) != 1) DO_ERROR;
	if (read(file, buffer, 2) != 2)  DO_ERROR;
	
	/* Temperatur interpretieren/ausgeben */
	if (buffer[0] & 0b10000000) sign = '-'; else sign = '+';
	if (buffer[1] & 0b10000000) dec = 5; else dec = 0;
	printf("%c%i.%i°C\n", sign, (buffer[0] & 0b01111111), dec);
	
	/* Ende */	
	close(file);
	exit(0);
}
