#!/bin/bash
#######################################################################
#
#   LM75 auslesen (via i2c-Tools)
#  ==============================
#        Uwe Berger, 2012
#
#######################################################################

I2C_BUS=2
ADDR_LM75=0x49

# Temperatur auslesen
VAL=$((16#$(i2cget -y "$I2C_BUS" "$ADDR_LM75" 0 w | sed -e 's/^0x//')))

LB=$(($VAL & $((2#11111111))))
HB=$(($VAL>>8))

# Vorzeichen interpretieren
if [ $(($LB & $((2#10000000)))) -eq 0 ] 
then SIGN="+"
else SIGN="-"
fi

# Vorzeichenbit rauskanten
lb=$(($LB & $((2#01111111))))

# Nachkomma interpretieren
if [ $HB -ge 128 ] 
then DEC=5
else DEC=0
fi

echo "$SIGN$LB,$DEC°C"
