#!/bin/bash
##########################################################
#
#  Ansteuerung SAA1064 (via i2c-Tools)
#  ===================================
#         Uwe Berger, 2012
#
#  Kommandosyntax:
#  ---------------
#  saa1064.sh <4-stellige Zahl>
#
##########################################################

I2C_BUS=2
ADDR_7SEGM=0x38

#      0    1    2    3    4    5    6    7    8    9
SEGM=(0x3F 0x06 0x5B 0x4F 0x66 0x6D 0x7D 0x07 0x7F 0x6F)

# Wertpruefung
VAL=$1
if [ $VAL -gt 9999 ]
then
	echo "Zahl zu gross!"
	exit
fi

# Initialisierung SAA1064
i2cset -y "$I2C_BUS" "$ADDR_7SEGM" 0x00 0x77

# Zahl ausgeben
i2cset -y "$I2C_BUS" "$ADDR_7SEGM" 0x01 ${SEGM[$((VAL/1000))]}
VAL=$(($VAL%1000))
i2cset -y "$I2C_BUS" "$ADDR_7SEGM" 0x02 ${SEGM[$(($VAL/100))]}
VAL=$(($VAL%100))
i2cset -y "$I2C_BUS" "$ADDR_7SEGM" 0x03 ${SEGM[$(($VAL/10))]}
VAL=$(($VAL%10))
i2cset -y "$I2C_BUS" "$ADDR_7SEGM" 0x04 ${SEGM[$VAL]}
